con
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  XTiles = 8
  YTiles = 6
  xpix = xtiles * 16 - 1
  ypix = ytiles * 16 - 1
  paramcount = 14

  Bitmapp = $7400
  DBuff = $6800
  _free = $2000 >> 2

  KUp = 194
  KDn = 195
  KH  = 193
  KV  = 192

  MBL = 6
  
obj
  'vga : "VGA"
  vga : "TV"
  gr : "Graphics"
  key : "Keyboard"
  nrs : "Simple_Numbers"
  'minne : "i2cobject"
  minne : "Minne"
  'mus : "FalldownMusic"
var
  long              tv_status                         '0/1/2 = off/visible/invisible                  read-only
  long              tv_enable                         '0/? = off/on                                   write-only
  long              tv_pins                           '%ppmmm = pins                                  write-only
  long              tv_mode                           '%ccinp = chroma,interlace,ntsc/pal,swap        write-only
  long              tv_screen                         'pointer to screen (words)                      write-only
  long              tv_colors                         'pointer to colors (longs)                      write-only
  long              tv_hc                             'horizontal cells                               write-only
  long              tv_vc                             'vertical cells                                 write-only
  long              tv_hx                             'horizontal cell expansion                      write-only
  long              tv_vx                             'vertical cell expansion                        write-only
  long              tv_ho                             'horizontal offset                              write-only
  long              tv_vo                             'vertical offset                                write-only
  long              tv_broadcast                      'broadcast frequency (Hz)                       write-only
  long              tv_auralcog                       'aural fm cog  
'  long  tv_broadcast  'broadcast frequency (Hz)                write-only
'  long  tv_auralcog   'aural fm cog                            write-only

  word  screen[xtiles * ytiles]
  long  colors[64]

  word X1[MBL]
  word Y1[MBL]


  word P1X
  word P1Y

  word P2X
  word P2Y

  word NNR
  
  long SEED

  long score

  long HS[5]
  byte HSN[10 * 5]
  byte tmps[10 * 2]
  byte InEEPROM
  byte players
pub main | i , tx,ty, sm,g
  inEEPROM := 0
  key.start(26,27)
  
  longmove(@tv_status, @tvparams, paramcount)
  tv_screen := @screen
  tv_colors := @colors
  vga.start(@tv_status)

  'init colors
  repeat i from 0 to 63
    colors[i] := $00001010 * (5+4) & $F + $2B060C02

  'init tile screen
  repeat tx from 0 to tv_hc - 1
    repeat ty from 0 to tv_vc - 1
      screen[ty * tv_hc + tx] := bitmapp >> 6 + ty + tx * tv_vc + ((1 & $3F) << 10)

  'start and setup graphics
  gr.start                                   
  gr.setup(xtiles, ytiles, 0, 0, dbuff)
  minne.start
  gr.color(2)
  colors[0] := $02
  colors[1] := $BB_1B_6C_02
  gr.pix(0,0,0,@mainscreen)
  'gr.text(0,0,nrs.hex(minne.readlocation(%1010_0000,0,16,8),2))
  'gr.text(0,16,nrs.hex(minne.readlocation(%1010_0000,2,16,8),2))
  'gr.textmode(2,4,6,%0101)
  'gr.text(xpix/2,ypix/2,string("Falldown"))
  'gr.text(xpix/2,ypix/2,nrs.hex(i2c.i2cread(0,8),2))

  'gr.text(xpix/2,20, string("Loading..."))  
  gr.copy(bitmapp)
  seed := 12032
  colors[0] := $02
  waitcnt(cnt + clkfreq * 5)
  if key.present == 0
    gr.clear
    gr.textmode(1,4,6,%101)
    gr.text(xpix/2,ypix/2,string("No keyboard!"))
    gr.copy(bitmapp)
    repeat
      waitcnt(cnt + clkfreq * 10)
  

  colors[1] := $BB_1B_6C_02
  repeat
    players := 1
    initmenu
    i := menu
    if i == 1
      initgame       
      if players == 1
        rungame
      else
        run2pgame
    if i == 2
      ShowHS
    if i == 3
      SaveEEPROM
    if i == 4
      gr.clear
      gr.text(0,ypix - 16,string("Do you really want to"))
      gr.text(0,ypix - 32,string("clear the highscores?"))
      g:=0
      gr.copy(bitmapp)
      repeat while g == 0
        i := key.getkey
        if i == "Y" or i == "y"
          g := 1
        if i == "N" or i == "n"
          g := 2
      if g == 1
        repeat i from 0 to 4
          hs[i] := 0
        repeat i from 0 to 5 * 10
          hsn[i] := 0  

      i := 4      

pri SaveEEPROM | i, OK, t, g
  gr.clear
  gr.color(3)
  gr.text(0,ypix - 16,string("Do you want to save?"))
  gr.text(0,ypix - 32,string("All data on locations"))
  gr.text(0,ypix - 48,nrs.hex(@hs,4))
  gr.text(30,ypix - 48,string("-"))
  gr.text(40,ypix - 48,nrs.hex(@hsn[5*10],4))
  gr.text(0,ypix - 64,string("will be deleted."))
  gr.text(0,ypix - 80,string("Continue? Y/N"))
  gr.copy(bitmapp)
  g:=0
  repeat while g == 0
    t := key.getkey
    if t == "Y" or t == "y"
      g := 1
    if t == "N" or t == "n"
      g := 2
  if g == 2
    return
  gr.clear
  gr.color(2)
  gr.textmode(1,1,6,0)
  gr.text(0, ypix - 16,string("Saving..."))
  repeat i from 0 to 4
    minne.writeEEPROM(28 << 18 | @hs[i],@hs[i],1)
    gr.plot(0,0)
    gr.line(xpix / 5 * (i+1),0)
    gr.plot(0,1)
    gr.line(xpix / 5 * (i+1),1)
    gr.plot(0,2)
    gr.line(xpix / 5 * (i+1),2)
    gr.copy(bitmapp)
    minne.readEEPROM(28 << 18 | @hs[i],@hs[i],1)
    waitcnt(cnt + clkfreq / 10)
  gr.color(0)
  gr.quad(0,0,0,2,xpix,2,xpix,0)
  gr.copy(bitmapp)
  gr.color(2)
  i := 0
  repeat i from 0 to 5 * 10
    minne.writeEEPROM(28 << 18 | @hsn[i],@hsn[i],1)
    gr.plot(0,0)
    gr.line((xpix / (5 * 10)) * (i+1),0)
    gr.plot(0,1)
    gr.line((xpix / (5 * 10)) * (i+1),1)
    gr.plot(0,2)
    gr.line((xpix / (5 * 10)) * (i+1),2)
    gr.copy(bitmapp)
    minne.readEEPROM(28 << 18 | @hsn[i],@hsn[i],1)
    waitcnt(cnt + clkfreq / 10)  
    
pri ShowHS| i
  colors[0] := $BB
  key.clearkeys
  gr.clear
  gr.textmode(1,1,6,%0100)
  gr.color(1)
  gr.text(xpix/2,ypix-16,string("Highscores"))
  repeat i from 0 to 4
    gr.textmode(1,1,6,0)
    gr.text(0,ypix - (i + 2) * 16,nrs.dec(i+1))
    gr.finish
    gr.text(xpix - 30,ypix - (i + 2) * 16, nrs.decx(hs[i],4))
    gr.finish
    gr.color(2)
    gr.text(20,ypix - (i + 2) * 16, @hsn[i * 10])
    gr.finish
    gr.color(1)
  gr.copy(bitmapp)
  repeat until key.getkey == 13    
  
pri initmenu
  colors[0] := $6B
  key.clearkeys
  
pri menu : doThis | i,strptr
  dothis := 1
  gr.textmode(1,1,6,0)
  repeat
    gr.clear
    repeat i from 1 to 4
      if players == 1
        strptr := lookup(i: @ply,@hss,@shs,@delhs)
      else
        strptr := lookup(i: @pl2p, @hss, @shs,@delhs)
      if i == dothis
        gr.color(1)
      else
        gr.color(2)
      gr.text(5,(4 - i) * 16,strptr)
    gr.copy(bitmapp)
    i := key.getkey
    if i == kup
      dothis--
    if i == kdn
      dothis++
    if i == kh and dothis == 1
      players ++
      if players > 2
        players := 2
    if i == kv and dothis == 1
      players --
      if players < 1
        players := 1
    if i == 13
      return dothis
    if dothis > 4
      dothis := 4
    if dothis < 1
      dothis := 1
               
pri initgame|i
  colors[0] := $02
  repeat i from 0 to MBL - 1
    x1[i] := 15
    y1[i] := 0
    '2[i] := xpix - 10
    'y2[i] := 0

  p1x := xpix / 2
  p1y := ypix
  p2x := p1x - 5
  p2y := p1y
  nnr := 0

pri rungame| ncnt,i, NBlk, bf, ly ,speed, upspeed, level
  nblk := 0
  score := 0
  speed := 30
  level:= 1
  upspeed := 0
  gr.textmode(1,1,6,0)
  repeat
    'ncnt := cnt + (clkfreq / 10)
    waitcnt(cnt + clkfreq / speed)
    gr.clear
    gr.color(1)
    repeat i from 0 to MBL - 1
      bf := 0
      'if x1[i] == 0

      'else
      if y1[i] == 0
      else
        if y1[i] > p1y - 2
          if y1[i] < p1y + 4
            if p1x < x1[i] + 3
              p1y := y1[i] + 2
              bf := 1
            if p1x > x1[i] + 18  
              p1y := y1[i] + 2
              bf := 1
        y1[i]++
        gr.plot(x1[i],y1[i])
        gr.line(0,y1[i])
        gr.plot(x1[i] + 20,y1[i])
        gr.line(xpix,y1[i])
        
        'y1[i]++
        'gr.quad(x1[i],y1[i],0,y1[i],0,y1[i] - 10,x1[i],y1[i] - 10)
        'gr.quad(x2[i],y2[i],xpix,y2[i],xpix,y2[i] - 10,x2[i],y2[i] - 10)
    ly := p1y
    nblk++
    if nblk == 32
      score++
      upspeed ++
      x1[nnr] := (?seed >> 16) * (xpix - 20) / $FFFF
      'x2[nnr] := y1[nnr] + 20
      y1[nnr] := 1
      'y2[nnr] := 1
      nnr++
      if nnr == mbl
        nnr:= 0
      nblk := 0
    if bf == 0
      p1y--
    if key.keystate(kv)
      p1x-=2
    if key.keystate(kh)
      p1x+= 2
    if p1x < 4
      p1x := 4
    if p1x > xpix - 3
      p1x := xpix - 3
    gr.pix(p1x,p1y,0,@boll)
    if p1y == 0
      p1y := 1
    if p1y > ypix
      viewscore
      return
    if upspeed => 20
      speed += 20
      level++
      upspeed := 0
    gr.color(3)
    gr.text(0,ypix - 16,nrs.decx(score,4))
    gr.finish
    gr.text(0,0,nrs.decx(level,2)) 
    gr.copy(bitmapp)
    
            
pri ViewScore | i
  gr.textmode(2,4,6,%0101)
  gr.color(3)
  gr.text(xpix/2,ypix/2,string("Game Over"))
  gr.copy(bitmapp)
  waitcnt(cnt + clkfreq * 2)
  gr.clear
  gr.textmode(1,1,6,0)
  gr.text(0, ypix - 16,string("Score:"))
  gr.copy(bitmapp)
  waitcnt(cnt + clkfreq)
  gr.text(xpix - 30, ypix - 16, nrs.decx(score,4))
  gr.copy(bitmapp)
  waitcnt(cnt + clkfreq)
  gr.text(0,ypix - 32,string("Highscore:"))
  gr.copy(bitmapp)
  waitcnt(cnt + clkfreq)
  gr.text(xpix - 30,ypix - 32, nrs.decx(hs,4))
  gr.copy(bitmapp)
  waitcnt(cnt + clkfreq)        
  i := UpdHS
  if i > 0
    gr.text(0,ypix - 48,string("Rank:"))
    gr.copy(bitmapp)
    waitcnt(cnt + clkfreq)
    gr.text(xpix-12,ypix-48,nrs.dec(i))
    gr.copy(bitmapp)
    waitcnt(cnt + clkfreq)
    entername(i - 1) 
  gr.text(0,0,string("Press enter"))
  gr.copy(bitmapp)
  repeat until key.getkey == 13
pri EnterName(HsNr)| ptr , tmp
  ptr := 0
  gr.text(0,ypix - 64,string("Enter name:"))
  key.clearkeys
  repeat
    gr.color(0)
    gr.quad(xpix - (12 + 6 * 8) ,ypix - 49,xpix,ypix - 49,xpix,ypix - 64,xpix - (12 + 6 * 8),ypix - 64)
    gr.color(3)
    gr.text(xpix - (12 + 6 * 8),ypix - 64,@hsn[hsnr * 10])
    gr.copy(bitmapp)
    tmp := key.getkey
    if tmp == 13
      return
    elseif tmp == 200
      if ptr > 0
        ptr--
        hsn[hsnr * 10 + ptr] := 0
    else 
      if ptr < 9
        hsn[hsnr * 10 + ptr] := tmp
        ptr ++
      
          
pri Run2PGame| ncnt,i, NBlk, bf, bf2, ly ,speed, upspeed, level
  nblk := 0
  score := 0
  speed := 30
  level:= 1
  upspeed := 0
  gr.textmode(1,1,6,0)
  repeat
    'ncnt := cnt + (clkfreq / 10)
    waitcnt(cnt + clkfreq / speed)
    gr.clear
    gr.color(1)
    bf := 0
    bf2 := 0
    repeat i from 0 to MBL - 1
      'if x1[i] == 0

      'else
      if y1[i] == 0
      else
        if y1[i] > p1y - 2
          if y1[i] < p1y + 4
            if p1x < x1[i] + 3
              p1y := y1[i] + 2
              bf := 1
            if p1x > x1[i] + 18  
              p1y := y1[i] + 2
              bf := 1
        if y1[i] > p2y - 2
          if y1[i] < p2y + 4
            if p2x < x1[i] + 3
              p2y := y1[i] + 2
              bf2 := 1
            if p2x > x1[i] + 18  
              p2y := y1[i] + 2
              bf2 := 1
        y1[i]++
        gr.plot(x1[i],y1[i])
        gr.line(0,y1[i])
        gr.plot(x1[i] + 20,y1[i])
        gr.line(xpix,y1[i])
        
        'y1[i]++
        'gr.quad(x1[i],y1[i],0,y1[i],0,y1[i] - 10,x1[i],y1[i] - 10)
        'gr.quad(x2[i],y2[i],xpix,y2[i],xpix,y2[i] - 10,x2[i],y2[i] - 10)
    ly := p1y
    nblk++
    if nblk == 32
      score++
      upspeed ++
      x1[nnr] := (?seed >> 16) * (xpix - 20) / $FFFF
      'x2[nnr] := y1[nnr] + 20
      y1[nnr] := 1
      'y2[nnr] := 1
      nnr++
      if nnr == mbl
        nnr:= 0
      nblk := 0
    if bf == 0
      p1y--
    if key.keystate(kv)
      p1x-=2
    if key.keystate(kh)
      p1x+= 2
    if p1x < 4
      p1x := 4
    if p1x > xpix - 3
      p1x := xpix - 3

    if bf2 == 0
      p2y--
    if key.keystate("a")
      p2x-=2
    if key.keystate("s")
      p2x+= 2
    if p2x < 4
      p2x := 4
    if p2x > xpix - 3
      p2x := xpix - 3


    gr.pix(p2x,p2y,0,@boll2)
    gr.pix(p1x,p1y,0,@boll)
    if p2y == 0
      p2y := 1
    if p2y > ypix
      gr.textmode(2,4,6,%0101)
      gr.color(3)
      gr.text(xpix/2,ypix/2,string("P1 won!"))
      gr.copy(bitmapp)
      repeat until key.getkey == 13
      return
    if p1y == 0
      p1y := 1
    if p1y > ypix
      gr.textmode(2,4,6,%0101)
      gr.color(3)
      gr.text(xpix/2,ypix/2,string("P2 won!"))
      gr.copy(bitmapp)
      repeat until key.getkey == 13
      return
    if upspeed => 20
      speed += 20
      level++
      upspeed := 0
    gr.color(3)
    gr.text(0,ypix - 16,nrs.decx(score,4))
    gr.finish
    gr.text(0,0,nrs.decx(level,2)) 
    gr.copy(bitmapp)
pri UpdHS : Plac | i, s, t
  s:= 0
  repeat i from 0 to 4
    if s == 0
      if score > hs[i]
        s := 1
        t := hs[i]
        bytemove(@tmps[0],@hsn[i * 10],10)
        plac := i + 1
        hs[i] := score
        bytefill(@hsn[i * 10], 0,10)
        'hsn[i * 4 + 3] := 0
    else
      s := hs[i]
      bytemove(@tmps[10],@hsn[i * 10], 10)
      hs[i] := t
      bytemove(@hsn[i * 10],@tmps[0],10)
      t := s
      bytemove(@tmps[0], @tmps[10],10)
      s := 1 
dat
ply     byte "Play 1 Player",0
pl2p    byte "Play 2 Players",0
hss     byte "Highscores",0
shs     byte "Save highscores",0
delhs   byte "Clear highscores",0

tvparams                long    0               'status
                        long    1               'enable
                        'long  %011_0000        'pins Old Board
                        long    %001_0101        'pins New Board
                        long    %0000           'mode
                        long    0               'screen
                        long    0               'colors
                        long    xtiles         'hc
                        long    ytiles         'vc
                        long    20              'hx
                        long    2               'vx
                        long    0               'ho
                        long    0               'vo
                        long    60_000_000      '_xinfreq<<4 'broadcast
                        long    0               'auralcog   

boll    word
        byte 1,7,4,0
        word %%00222000
        word %%02222200
        word %%22222220
        word %%22222220
        word %%22222220
        word %%02222200
        word %%00222000

boll2   word
        byte 1,7,4,0
        word %%00333000
        word %%03333300
        word %%33333330
        word %%33333330
        word %%33333330
        word %%03333300
        word %%00333000

mainscreen
word
byte 16, 95, 0,0
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000011, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00001111, %%11000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00001111, %%11000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00011111, %%11100000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00011111, %%11100000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00001111, %%11000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00001111, %%11000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000011, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%22222222, %%22222222, %%22222222, %%22222222, %%22222220, %%00000000, %%00000000, %%00000022, %%22222222, %%22222222, %%22222222, %%22222222, %%22222222, %%22222222, %%22222222, %%22222222
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00033333, %%33333300, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%33330003, %%00000033, %%30000000, %%00000000, %%00000003, %%30000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000333, %%30000003, %%00000000, %%03333300, %%00000000, %%00000003, %%30000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00033000, %%00000003, %%00000000, %%00000000, %%00000000, %%00000030, %%30000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%03300000, %%00000003, %%30000000, %%00000000, %%00000000, %%00000030, %%30000000, %%00000330, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%33000000, %%00000000, %%30000000, %%00000000, %%00000000, %%00000030, %%30000000, %%00000303, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%30000000, %%00000000, %%00000000, %%00000300, %%30000000, %%00003003, %%00000000, %%00000000, %%03000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%30000000, %%00000000, %%00000000, %%00000300, %%30000000, %%00003003, %%00000000, %%00000000, %%33000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%33000000, %%00000000, %%00000000, %%00000300, %%30000000, %%00030003, %%00000000, %%00000003, %%03000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%03000000, %%00000000, %%00000000, %%00000300, %%30000000, %%00030003, %%00000000, %%00000003, %%03000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%03000000, %%00000000, %%00000000, %%00000300, %%30000000, %%00030003, %%00000000, %%00000003, %%03000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%03000000, %%00000000, %%00000000, %%00000300, %%30000000, %%00300003, %%00000000, %%00000030, %%03000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%03000000, %%00000000, %%00000000, %%00000300, %%30000000, %%00300030, %%00000000, %%00000300, %%03000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%03000000, %%00000000, %%00000000, %%00000300, %%30000000, %%00300030, %%00000000, %%00000300, %%03000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%03000000, %%00000000, %%00000000, %%00000300, %%30000000, %%00300030, %%00000000, %%00000300, %%03000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%22222222, %%22222222, %%22222222, %%23222222, %%22222222, %%22222222, %%22222322, %%32200000, %%00300030, %%00000000, %%00223222, %%23222222, %%22222222, %%22222222, %%22222222, %%22222222
word %%00000000, %%00000000, %%00000000, %%03000000, %%00000000, %%00000000, %%00000303, %%00000000, %%00300300, %%00000000, %%00003000, %%03000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%03000000, %%00000000, %%00000000, %%00000303, %%00000000, %%00300300, %%00000000, %%00003000, %%03000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00003333, %%33000000, %%00000000, %%00000000, %%00000303, %%00000000, %%03000300, %%00000000, %%00003000, %%03000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00033000, %%03000000, %%00000000, %%00000000, %%00000330, %%00000000, %%03003000, %%00000000, %%00003000, %%03000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00030000, %%03000003, %%33333333, %%00000000, %%00000300, %%00000000, %%03003000, %%00000000, %%00003000, %%03000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00030000, %%30000333, %%00300033, %%30000000, %%00000330, %%00000000, %%03003000, %%00000000, %%00000300, %%03000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00033000, %%30003300, %%03000000, %%00300000, %%00000330, %%00000000, %%03030000, %%00000000, %%00000300, %%03000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00003330, %%30033000, %%33000000, %%00300000, %%00003030, %%00000000, %%03030000, %%00000000, %%00333300, %%03000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000033, %%33300000, %%30000000, %%00300000, %%00003030, %%00000000, %%03300000, %%00000003, %%33300300, %%03000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000003, %%00000000, %%30000000, %%03300000, %%00030030, %%00000000, %%00300000, %%00000333, %%00000300, %%30000000, %%00033333, %%00000000, %%00000333, %%33003000
word %%00000000, %%00000000, %%00000033, %%00000003, %%00000000, %%03300000, %%00030033, %%00000000, %%03300000, %%00003300, %%00000300, %%30000000, %%00330000, %%33333300, %%30000300, %%03333000
word %%00000000, %%00000000, %%00000030, %%00000003, %%00000000, %%33300000, %%00300003, %%00000000, %%03300000, %%00033000, %%00000300, %%30000000, %%03300000, %%33000300, %%30000300, %%03303003
word %%00000000, %%00000000, %%00000030, %%00000003, %%00000000, %%30300000, %%00300000, %%30000003, %%30300000, %%00333000, %%00000303, %%00000000, %%03300000, %%03003000, %%30003000, %%03003003
word %%00000000, %%00000000, %%00000330, %%00000003, %%00000000, %%30300000, %%03000000, %%03333330, %%00030000, %%33003000, %%00000303, %%00000000, %%33000000, %%03003000, %%30003000, %%03003003
word %%00000000, %%00000000, %%00000300, %%00000000, %%30000003, %%00300000, %%03000000, %%00000000, %%00033033, %%30003000, %%00000330, %%00000000, %%33000000, %%03003000, %%30003000, %%33003003
word %%00000000, %%00000000, %%00003000, %%00000000, %%33000033, %%00330000, %%30000000, %%00000000, %%00003330, %%00003300, %%00000330, %%00000000, %%30000000, %%03033003, %%30030000, %%30003003
word %%00000000, %%00000000, %%00033000, %%00000000, %%03000030, %%00033333, %%00000000, %%00000000, %%00000000, %%00000333, %%33333330, %%00000003, %%03000003, %%30030030, %%30030000, %%30003033
word %%00000000, %%00000000, %%00300000, %%00000000, %%00333300, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000033, %%30000030, %%00330033, %%00003300, %%30030000, %%30003030
word %%00000000, %%00000000, %%00300000, %%00000000, %%00000000, %%00000000, %%00000000, %%00011100, %%00000000, %%00000000, %%00000000, %%03333300, %%00033300, %%00000000, %%03300000, %%30003030
word %%00000300, %%00000000, %%03000000, %%00000000, %%00000000, %%00000000, %%00000000, %%01111111, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00003330
word %%00000300, %%00000000, %%30000000, %%00000000, %%00000000, %%00000000, %%00000000, %%01111111, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%22222322, %%22222223, %%22222222, %%22222222, %%22222222, %%22220000, %%00000000, %%11111111, %%10000000, %%22222222, %%22222222, %%22222222, %%22222222, %%22222222, %%22222222, %%22222222
word %%00000300, %%00000033, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%11111111, %%10000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000300, %%00003300, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%01111111, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000030, %%00030000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%01111111, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000003, %%33330000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00011100, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%22222222, %%22222222, %%22222222, %%22222222, %%22222222, %%22222222, %%22222222, %%22222222, %%22222222, %%22222222, %%00000000, %%00000000, %%00022222, %%22222222, %%22222222, %%22222222
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
                                                                                                                                                                                         